var CachePriority={Low:1,Normal:2,High:4};function Cache(maxSize){this.items={};this.count=0;if(maxSize==null)
maxSize=-1;this.maxSize=maxSize;this.fillFactor=.75;this.purgeSize=Math.round(this.maxSize*this.fillFactor);this.stats={};this.stats.hits=0;this.stats.misses=0;}
Cache.prototype.getItem=function(key){var item=this.items[key];if(item!=null){if(!this._isExpired(item)){item.lastAccessed=new Date().getTime();}else{this._removeItem(key);item=null;}}
var returnVal=null;if(item!=null){returnVal=item.value;this.stats.hits++;}else{this.stats.misses++;}
return returnVal;};Cache.prototype.setItem=function(key,value,options){function CacheItem(k,v,o){if((k==null)||(k==''))
throw new Error("key cannot be null or empty");this.key=k;this.value=v;if(o==null)
o={};if(o.expirationAbsoluteSecs!=null){d=new Date();d.setSeconds(d.getSeconds()+o.expirationAbsoluteSecs);o.expirationAbsolute=d;}
if(o.expirationAbsolute!=null)
o.expirationAbsolute=o.expirationAbsolute.getTime();if(o.priority==null)
o.priority=CachePriority.Normal;this.options=o;this.lastAccessed=new Date().getTime();}
if(this.items[key]!=null)
this._removeItem(key);this._addItem(new CacheItem(key,value,options));if((this.maxSize>0)&&(this.count>this.maxSize)){this._purge();}};Cache.prototype.clear=function(){for(var key in this.items){this._removeItem(key);}};Cache.prototype._purge=function(){var tmparray=new Array();for(var key in this.items){var item=this.items[key];if(this._isExpired(item)){this._removeItem(key);}else{tmparray.push(item);}}
if(tmparray.length>this.purgeSize){tmparray=tmparray.sort(function(a,b){if(a.options.priority!=b.options.priority){return b.options.priority-a.options.priority;}else{return b.lastAccessed-a.lastAccessed;}});while(tmparray.length>this.purgeSize){var ritem=tmparray.pop();this._removeItem(ritem.key);}}};Cache.prototype._addItem=function(item){this.items[item.key]=item;this.count++;};Cache.prototype._removeItem=function(key){var item=this.items[key];delete this.items[key];this.count--;if(item.options.callback!=null){var callback=function(){item.options.callback(item.key,item.value);};setTimeout(callback,0);}};Cache.prototype._isExpired=function(item){var now=new Date().getTime();var expired=false;if((item.options.expirationAbsolute)&&(item.options.expirationAbsolute<now)){expired=true;}
if(!expired&&(item.options.expirationSliding)){var lastAccess=item.lastAccessed+(item.options.expirationSliding*1000);if(lastAccess<now){expired=true;}}
return expired;};Cache.prototype.toHtmlString=function(){var returnStr=this.count+" item(s) in cache<br /><ul>";for(var key in this.items){var item=this.items[key];returnStr=returnStr+"<li>"+item.key.toString()+" = "+item.value.toString()+"</li>";}
returnStr=returnStr+"</ul>";return returnStr;};Cache.prototype.fetchOrGet=function(key,data,expiry_seconds,url,get_data,callback,data_format){self_cache=this;if(data==null&&data!==false)
data=this.getItem(key);if(!data){$.get(url,get_data,function(ret_data){self_cache.setItem(key,ret_data,{"expirationAbsoluteSecs":expiry_seconds});callback(ret_data);},data_format)}else
callback(data);}
Date.prototype.setISO8601=function(string){var regexp="([0-9]{4})(-([0-9]{2})(-([0-9]{2})"+"(T([0-9]{2}):([0-9]{2})(:([0-9]{2})(\.([0-9]+))?)?"+"(Z|(([-+])([0-9]{2}):([0-9]{2})))?)?)?)?";var d=string.match(new RegExp(regexp));var offset=0;var date=new Date(d[1],0,1);if(d[3]){date.setMonth(d[3]-1);}
if(d[5]){date.setDate(d[5]);}
if(d[7]){date.setHours(d[7]);}
if(d[8]){date.setMinutes(d[8]);}
if(d[10]){date.setSeconds(d[10]);}
if(d[12]){date.setMilliseconds(Number("0."+d[12])*1000);}
if(d[14]){offset=(Number(d[16])*60)+Number(d[17]);offset*=((d[15]=='-')?1:-1);}
offset-=date.getTimezoneOffset();time=(Number(date)+(offset*60*1000));this.setTime(Number(time));}